<script>
  import { createEventDispatcher } from 'svelte'
  import { get } from '../utils/request'

  export let field = {}
  export let value = null
  export let id = ""
  let items = []

  $: valueColumn = field.valueColumn || 'id'
  $: descriptionColumn = field.descriptionColumn || 'name'

  const dispatch = createEventDispatcher()

  // Get data
  let include = field.include
  /*
  let where = field.filters
  if (where) {
    // wher
    where = where.map(w => {
      const matches = w.value.match(/:(\w+):/)
      if (matches) {
        w.value = w.value.replace(matches[0], field.ModelField[matches[1]])
      }

      return w
    })
  }
   */

  get('/data', { include }, { Model: field.ModelField.targetModel })
    .then(({ data }) => {
      items = [ ...data.result ]
    })
    .catch(console.error)

  // Set new value to parent
  function setValue ($event) {
    dispatch('change', $event.target.value)
  }

  function getDescription (col, item) {
    const columns = col.split(',')
    return columns.map(column => {
      const subcolumns = column.split('.')
      let result = item
      subcolumns.forEach(c => {
        result = result && result[c] ? result[c] : result
      })

      return result
    }).join(' - ')
  }
</script>

<div class="select w-full">
  <select id={id} name="field_{field.ModelField.name}" class="w-full" bind:value on:change={setValue} required={field.required}>
    <option value="">...</option>
    {#each items as item}
      <option value={item[valueColumn]} selected={item[valueColumn] === value}>{getDescription(descriptionColumn, item)}</option>
    {/each}
  </select>
</div>
